% read Template image
t=imread('Coca_Cola T3 cropped.bmp');

% read Traget Image
f=imread('world.jpg');

Template=rgb2gray(t);
Target=rgb2gray(f);

[r1,c1]=size(Target);
[r2,c2]=size(Template);


 
% mean of template
tempMean=Template-mean(mean(Template));


%corrolate both images
corrMat=[];
for i=1:(r1-r2+1)
    for j=1:(c1-c2+1)
        tarMean=Target(i:i+r2-1,j:j+c2-1);
        tarMean=tarMean-mean(mean(tarMean));  % mean of image part under mask
        score=sum(sum(tarMean.*tempMean));
        corrMat(i,j)=score;
    end 
end

%find the max
[r,c]=max(corrMat);
[r3,c3]=max(max(corrMat));

i=c(c3);
j=c3;
result=Target;

%left border
for x=i:i+r2-1
   for y=j
       result(x,y)=255;
   end
   for y=j+1
       result(x,y)=255;
   end
      for y=j+2
       result(x,y)=255;
   end
end

%right border
for x=i:i+r2-1
   for y=j+c2-1
       result(x,y)=255;
   end
   for y=j+c2-2
       result(x,y)=255;
   end
end

%top border
for x=i
   for y=j:j+c2-1
       result(x,y)=255;
   end

end
for x=i-1
   for y=j:j+c2-1
       result(x,y)=255;
   end
end
for x=i-2
   for y=j:j+c2-1
       result(x,y)=255;
   end
end

%bottom border
for x=i+r2-1
   for y=j:j+c2-1
       result(x,y)=255;
   end
end

figure,
subplot(2,2,1),imshow(Template);title('Template');
subplot(2,2,2),imshow(Target);title('Target');
subplot(2,2,3),imshow(result);title('Result');